<?php
// Script créé par FranK
// Le script permet de générer un XML lisible par eedomus
// à partir des données FlipR récupérées via Oauth2
// encodage iso-8859-1 pour les accents
// https://apis.goflipr.com/Help
// Version 1 : 18 Juillet 2019 - Version initiale
// Version 2 : 20 Juillet 2019 - Ajout gestion erreur FliprID erroné

$fliprID=getArg('fliprid', $mandatory = true, $default = '');
$ForcedReload=getArg('forcedreload', $mandatory = false, $default = false);

if ($ForcedReload)
{
  $CACHE_DURATION = 0; // minutes
}
else
{
  $CACHE_DURATION = 30; // minutes
}

$ApiUrl = 'https://apis.goflipr.com';
$username = getArg('username');
$password = getArg('password');

$last_xml_success = loadVariable('last_xml_success');

// On renvoie directement le contenu du cache si la dernière requête date de moins de CACHE_DURATION
if ((time() - $last_xml_success) / 60 < $CACHE_DURATION)
{
	sdk_header('text/xml');
	$cached_xml = loadVariable('cached_xml');
	echo $cached_xml;
	die();
}

// Construction de la requête POST d'authentification
$grant_type = 'password';
$postdata = 'grant_type='.$grant_type.'&username='.$username.'&password='.$password;
$headers = array("Content-Type: application/x-www-form-urlencoded");
	
// Execution de la requête et récupération du résultat
$response = httpQuery($ApiUrl.'/OAuth2/token', 'POST', $postdata, NULL, $headers);

// On décode le JSON pour vérifier que tout c'est bien passé
$params = sdk_json_decode($response);
if ($params['error'] != '')
{
	die("Erreur lors de l'authentification: <b>".$params['error'].'</b> (grant_type = '.$grant_type.')');
}
	
if (isset($params['refresh_token']))
{
	$access_token = $params['access_token'];
	saveVariable('access_token', $access_token);
	saveVariable('refresh_token', $params['refresh_token']);
}
else if ($access_token == '')
{
	die("Erreur lors de l'authentification");
}


// Constructin de la requête GET
$headers = array("Authorization: Bearer ".$access_token);

// Lecture des dernières données
$result_data = httpQuery($ApiUrl.'/modules/'.$fliprID.'/survey/last', 'GET', NULL, NULL, $headers);

// On décode le JSON pour récupérer les données
$json_data = sdk_json_decode($result_data);

if ($json_data['error'] != '')
{
  die("Erreur lors de la lecture des data: <b>".$json_data['error']['message'].'</b>');
}

if ($json_data['Message'] != '')
{
  die("Erreur lors de la lecture des data: <b>".$json_data['Message'].'</b>');
}

// Si tout c'est bien passé, on construit le résultat XML avec les données que j'ai jugées utiles
sdk_header('text/xml');
$XmlResult.="<?xml version='1.0' encoding='ISO-8859-1'?><root><cached>";
$XmlResult.='<Cachestatus>0</Cachestatus>';
$XmlResult.='<CacheTime>'.date(DATE_RFC2822).'</CacheTime>';
$XmlResult.='</cached>';
$XmlResult.='<Battery>'.$json_data['Battery']['Deviation'].'</Battery>';
$XmlResult.='<Conductivity>'.$json_data['Conductivity']['Level'].'</Conductivity>';
$XmlResult.='<PH>'.$json_data['PH']['Value'].'</PH>';
$XmlResult.='<Temperature>'.$json_data['Temperature'].'</Temperature>';
$XmlResult.='<UV>'.$json_data['UvIndex'].'</UV>';
$XmlResult.='<Redox>'.$json_data['OxydoReductionPotentiel']['Value'].'</Redox>';
$XmlResult.='<Desinfectant>'.$json_data['Desinfectant']['Deviation'].'</Desinfectant>'.'</root>';
 
// On met à jour la date de la dernière récupération
saveVariable('last_xml_success', time());
  
// On stocke les données en cache
saveVariable('cached_xml', $XmlResult);
 
// On envoi le résultat en sortie (pour être utilisée par la box
echo $XmlResult;

?>